/*
 *************************************************************************
 *                                                                       *
 * Copyright 2000 Compaq Computer Corporation                            *
 *                                                                       *
 * COMPAQ Registered in U.S. Patent and Trademark Office.                *
 *                                                                       *
 *************************************************************************
 * IMPORTANT: Carefully read the License Terms below before              *
 * proceeding.  By use of these materials you agree to these terms.      *
 * If you do not agree to these terms, you may not use this software or  *
 * the accompanying documentation.                                       *
 *************************************************************************
 * LICENSE TERMS                                                         *
 * 1. GRANT                                                              *
 * Compaq Computer Corporation ("COMPAQ") grants you the right to use    *
 * and modify the following source code (the "Software") for use on any  *
 * number of computers.                                                  *
 * 2. COPYRIGHT                                                          *
 * The Software is owned by COMPAQ and its suppliers and is protected by *
 * copyright laws and international treaties.  Your use of the Software  *
 * and associated documentation is subject to the applicable copyright   *
 * laws and the express rights and restrictions of these terms.          *
 * 3. RESTRICTIONS                                                       *
 * You may not sell, rent, lease, license or otherwise commercially      *
 * transfer the Software.  You may not remove any copyright, trademark,  *
 * or other proprietary notices from the Software or the associated      *
 * documentation.   You are responsible for compliance with all          *
 * applicable export or re-export control laws and regulations if you    *
 * export the Software. This license is governed by and is to be         *
 * construed under the laws of the State of Texas.                       *
 *                                                                       *
 * DISCLAIMER OF WARRANTY AND LIABILITY                                  *
 * Compaq shall not be liable for technical or editorial errors or       *
 * omissions contained herein. The information contained herein is       *
 * subject to change without notice.                                     *
 *                                                                       *
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.       *
 * THE ENTIRE RISK ARISING OUT OF THE USE OF THIS SOFTWARE REMAINS WITH  *
 * RECIPIENT.  IN NO EVENT SHALL COMPAQ BE LIABLE FOR ANY DIRECT,        *
 * CONSEQUENTIAL, INCIDENTAL, SPECIAL, PUNITIVE OR OTHER DAMAGES         *
 * WHATSOEVER (INCLUDING WITHOUT LIMITATION DAMAGES FOR LOSS OF BUSINESS *
 * PROFITS, BUSINESS INTERRUPTION, OR LOSS OF BUSINESS INFORMATION),     *
 * EVEN IF COMPAQ HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES    *
 * AND WHETHER IN AN ACTION OF CONTRACT OR TORT INCLUDING NEGLIGENCE.    *
 *                                                                       *
 * If you have any questions concerning this license, please contact:    *
 * Compaq Computer Corporation, Software Business Practices, ZKO1-2/D22, *
 * 110 Spit Brook Road, Nashua, NH. 03062-2698.                          *
 *                                                                       *
 *************************************************************************
 */

#include "vms_jackets.h"
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
/**********************************************************************/
/*  Jacket routines to handle VMS and decc limits                     */
/*                                                                    */
/*  Routine: GENERIC_ACCESS_JACKET                                    */
/*                                                                    */
/*  Jacket for: access                                                */
/*                                                                    */
/*  Reason:  java check to see if directories exist via access        */
/*           without it import java.io.* would fail                   */
/*  Fix:     if access fails and mode = F_OK, add a .dir onto the end */
/*                                                                    */
/**********************************************************************/

/*
** Calls in here to getcwd need to go to the jacketted version.
*/
#define getcwd GENERIC_GETCWD_JACKET

int GENERIC_ACCESS_JACKET(char *access_file_spec, int mode )
{
   int return_int,status;
   char *base;
   char *file_spec;
   char temp_string[TEMP_STRING_SIZE];
   char temp_dir_string[TEMP_STRING_SIZE];
   file_spec =  GENERIC_VMS_Filename_parser(access_file_spec,
                                            temp_string,
					    GENERIC_K_STRING_TYPE_UNKNOWN,
                                            &status);
   
   if ((strlen(access_file_spec) < 4) &&
	(!strcmp(access_file_spec,".") ||
	!strcmp(access_file_spec,"./") ||
	!strcmp(access_file_spec,"<>") || 
	!strcmp(access_file_spec,"[]") ||
	!strcmp(access_file_spec,".//")))
   { /* for cwd */
	file_spec = getcwd(temp_string,TEMP_STRING_SIZE);
   }
   GENERIC_TRACE("access_Jacket: Mapping:", access_file_spec, "To:", file_spec);
   if (!(return_int = access(file_spec,mode)))
	return( return_int);
   else
/*
     ignore mode problem passed boundary test 1015 1019 1030 1032
     check for directory on all tests 
     if  (mode ==  F_OK)
*/
     if (!strchr(file_spec,'.'))  /* only if it doesn't have a '.' then check for .dir*/
	{
	  char temp_string[2048];
	  strcpy(temp_string,file_spec);
	  strcat(temp_string,".dir");
	  return_int =access(temp_string,mode);
	  if (!return_int) /*worked */
             return(return_int);
          else
		{
		/* ok let's try putting in /dev/000000/file*/
			char *temp_ptr;
			char temp_string1[2048];
			strcpy(temp_string1,temp_string);

			temp_ptr = strchr(&temp_string1[1],'/');
			if (!temp_ptr) /* doesn't have second '/' */
				return (return_int);

			*temp_ptr = '\0';        /* null the second '/' */

			strcat(temp_string1,"/000000");/* add mfd to string*/

                        temp_ptr = strchr(&temp_string[1],'/'); /*get rest*/
			strcat(temp_string1,temp_ptr);
			return_int = access(temp_string1,mode);
		}
	}

   file_spec =  GENERIC_VMS_Filename_parser(access_file_spec,
                                            temp_dir_string,
					    GENERIC_K_STRING_TYPE_DIRECTORY,
                                            &status);
   if (strcmp(temp_string,temp_dir_string))/*diff check for directory*/
	{
	return_int = access(file_spec,mode);
	};
	return( return_int);
}
